diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-mac.cc ns-3.39/src/lte/model/lte-enb-mac.cc
--- ns-3.38/src/lte/model/lte-enb-mac.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-mac.cc	2023-07-05 14:23:48.009428000 -0700
@@ -21,18 +21,15 @@
  *          Biljana Bojovic <biljana.bojovic@cttc.es> (Carrier Aggregation)
  */
 
-#include "lte-amc.h"
+#include "lte-enb-mac.h"
+
+#include "lte-common.h"
 #include "lte-control-messages.h"
-#include "lte-enb-net-device.h"
-#include "lte-ue-net-device.h"
+#include "lte-enb-cmac-sap.h"
+#include "lte-mac-sap.h"
+#include "lte-radio-bearer-tag.h"
 
-#include "ns3/lte-enb-cmac-sap.h"
-#include "ns3/lte-mac-sap.h"
 #include <ns3/log.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-enb-mac.h>
-#include <ns3/lte-radio-bearer-tag.h>
-#include <ns3/lte-ue-phy.h>
 #include <ns3/packet.h>
 #include <ns3/pointer.h>
 #include <ns3/simulator.h>
@@ -144,8 +141,8 @@
      */
     EnbMacMemberFfMacSchedSapUser(LteEnbMac* mac);
 
-    void SchedDlConfigInd(const struct SchedDlConfigIndParameters& params) override;
-    void SchedUlConfigInd(const struct SchedUlConfigIndParameters& params) override;
+    void SchedDlConfigInd(const SchedDlConfigIndParameters& params) override;
+    void SchedUlConfigInd(const SchedUlConfigIndParameters& params) override;
 
   private:
     LteEnbMac* m_mac; ///< the MAC
@@ -157,13 +154,13 @@
 }
 
 void
-EnbMacMemberFfMacSchedSapUser::SchedDlConfigInd(const struct SchedDlConfigIndParameters& params)
+EnbMacMemberFfMacSchedSapUser::SchedDlConfigInd(const SchedDlConfigIndParameters& params)
 {
     m_mac->DoSchedDlConfigInd(params);
 }
 
 void
-EnbMacMemberFfMacSchedSapUser::SchedUlConfigInd(const struct SchedUlConfigIndParameters& params)
+EnbMacMemberFfMacSchedSapUser::SchedUlConfigInd(const SchedUlConfigIndParameters& params)
 {
     m_mac->DoSchedUlConfigInd(params);
 }
@@ -179,14 +176,13 @@
      */
     EnbMacMemberFfMacCschedSapUser(LteEnbMac* mac);
 
-    void CschedCellConfigCnf(const struct CschedCellConfigCnfParameters& params) override;
-    void CschedUeConfigCnf(const struct CschedUeConfigCnfParameters& params) override;
-    void CschedLcConfigCnf(const struct CschedLcConfigCnfParameters& params) override;
-    void CschedLcReleaseCnf(const struct CschedLcReleaseCnfParameters& params) override;
-    void CschedUeReleaseCnf(const struct CschedUeReleaseCnfParameters& params) override;
-    void CschedUeConfigUpdateInd(const struct CschedUeConfigUpdateIndParameters& params) override;
-    void CschedCellConfigUpdateInd(
-        const struct CschedCellConfigUpdateIndParameters& params) override;
+    void CschedCellConfigCnf(const CschedCellConfigCnfParameters& params) override;
+    void CschedUeConfigCnf(const CschedUeConfigCnfParameters& params) override;
+    void CschedLcConfigCnf(const CschedLcConfigCnfParameters& params) override;
+    void CschedLcReleaseCnf(const CschedLcReleaseCnfParameters& params) override;
+    void CschedUeReleaseCnf(const CschedUeReleaseCnfParameters& params) override;
+    void CschedUeConfigUpdateInd(const CschedUeConfigUpdateIndParameters& params) override;
+    void CschedCellConfigUpdateInd(const CschedCellConfigUpdateIndParameters& params) override;
 
   private:
     LteEnbMac* m_mac; ///< the MAC
@@ -198,48 +194,45 @@
 }
 
 void
-EnbMacMemberFfMacCschedSapUser::CschedCellConfigCnf(
-    const struct CschedCellConfigCnfParameters& params)
+EnbMacMemberFfMacCschedSapUser::CschedCellConfigCnf(const CschedCellConfigCnfParameters& params)
 {
     m_mac->DoCschedCellConfigCnf(params);
 }
 
 void
-EnbMacMemberFfMacCschedSapUser::CschedUeConfigCnf(const struct CschedUeConfigCnfParameters& params)
+EnbMacMemberFfMacCschedSapUser::CschedUeConfigCnf(const CschedUeConfigCnfParameters& params)
 {
     m_mac->DoCschedUeConfigCnf(params);
 }
 
 void
-EnbMacMemberFfMacCschedSapUser::CschedLcConfigCnf(const struct CschedLcConfigCnfParameters& params)
+EnbMacMemberFfMacCschedSapUser::CschedLcConfigCnf(const CschedLcConfigCnfParameters& params)
 {
     m_mac->DoCschedLcConfigCnf(params);
 }
 
 void
-EnbMacMemberFfMacCschedSapUser::CschedLcReleaseCnf(
-    const struct CschedLcReleaseCnfParameters& params)
+EnbMacMemberFfMacCschedSapUser::CschedLcReleaseCnf(const CschedLcReleaseCnfParameters& params)
 {
     m_mac->DoCschedLcReleaseCnf(params);
 }
 
 void
-EnbMacMemberFfMacCschedSapUser::CschedUeReleaseCnf(
-    const struct CschedUeReleaseCnfParameters& params)
+EnbMacMemberFfMacCschedSapUser::CschedUeReleaseCnf(const CschedUeReleaseCnfParameters& params)
 {
     m_mac->DoCschedUeReleaseCnf(params);
 }
 
 void
 EnbMacMemberFfMacCschedSapUser::CschedUeConfigUpdateInd(
-    const struct CschedUeConfigUpdateIndParameters& params)
+    const CschedUeConfigUpdateIndParameters& params)
 {
     m_mac->DoCschedUeConfigUpdateInd(params);
 }
 
 void
 EnbMacMemberFfMacCschedSapUser::CschedCellConfigUpdateInd(
-    const struct CschedCellConfigUpdateIndParameters& params)
+    const CschedCellConfigUpdateIndParameters& params)
 {
     m_mac->DoCschedCellConfigUpdateInd(params);
 }
@@ -261,8 +254,8 @@
     void ReceiveLteControlMessage(Ptr<LteControlMessage> msg) override;
     void ReceiveRachPreamble(uint32_t prachId) override;
     void UlCqiReport(FfMacSchedSapProvider::SchedUlCqiInfoReqParameters ulcqi) override;
-    void UlInfoListElementHarqFeeback(UlInfoListElement_s params) override;
-    void DlInfoListElementHarqFeeback(DlInfoListElement_s params) override;
+    void UlInfoListElementHarqFeedback(UlInfoListElement_s params) override;
+    void DlInfoListElementHarqFeedback(DlInfoListElement_s params) override;
 
   private:
     LteEnbMac* m_mac; ///< the MAC
@@ -304,15 +297,15 @@
 }
 
 void
-EnbMacMemberLteEnbPhySapUser::UlInfoListElementHarqFeeback(UlInfoListElement_s params)
+EnbMacMemberLteEnbPhySapUser::UlInfoListElementHarqFeedback(UlInfoListElement_s params)
 {
-    m_mac->DoUlInfoListElementHarqFeeback(params);
+    m_mac->DoUlInfoListElementHarqFeedback(params);
 }
 
 void
-EnbMacMemberLteEnbPhySapUser::DlInfoListElementHarqFeeback(DlInfoListElement_s params)
+EnbMacMemberLteEnbPhySapUser::DlInfoListElementHarqFeedback(DlInfoListElement_s params)
 {
-    m_mac->DoDlInfoListElementHarqFeeback(params);
+    m_mac->DoDlInfoListElementHarqFeedback(params);
 }
 
 // //////////////////////////////////////
@@ -533,6 +526,14 @@
                 else
                 {
                     rnti = m_cmacSapUser->AllocateTemporaryCellRnti();
+
+                    if (rnti == 0)
+                    {
+                        // If rnti = 0, UE context was not created (not enough SRS)
+                        // Therefore don't send RAR for this preamble
+                        NS_LOG_INFO("UE context not created, no RAR to send");
+                        continue;
+                    }
                     NS_LOG_INFO("preambleId " << (uint32_t)it->first << ": allocated T-C-RNTI "
                                               << (uint32_t)rnti << ", sending RAR");
                 }
@@ -563,7 +564,7 @@
     FfMacSchedSapProvider::SchedDlTriggerReqParameters dlparams;
     dlparams.m_sfnSf = ((0x3FF & dlSchedFrameNo) << 4) | (0xF & dlSchedSubframeNo);
 
-    // Forward DL HARQ feebacks collected during last TTI
+    // Forward DL HARQ Feedbacks collected during last TTI
     if (!m_dlInfoListReceived.empty())
     {
         dlparams.m_dlInfoList = m_dlInfoListReceived;
@@ -617,7 +618,7 @@
     FfMacSchedSapProvider::SchedUlTriggerReqParameters ulparams;
     ulparams.m_sfnSf = ((0x3FF & ulSchedFrameNo) << 4) | (0xF & ulSchedSubframeNo);
 
-    // Forward DL HARQ feebacks collected during last TTI
+    // Forward DL HARQ Feedbacks collected during last TTI
     if (!m_ulInfoListReceived.empty())
     {
         ulparams.m_ulInfoList = m_ulInfoListReceived;
@@ -646,7 +647,7 @@
     {
         Ptr<DlHarqFeedbackLteControlMessage> dlharq =
             DynamicCast<DlHarqFeedbackLteControlMessage>(msg);
-        DoDlInfoListElementHarqFeeback(dlharq->GetDlHarqFeedback());
+        DoDlInfoListElementHarqFeedback(dlharq->GetDlHarqFeedback());
     }
     else
     {
@@ -893,21 +894,22 @@
     // 4.3.4 logicalChannelConfigListElement
     if (lcinfo.lcId != 0)
     {
-        struct FfMacCschedSapProvider::CschedLcConfigReqParameters params;
+        FfMacCschedSapProvider::CschedLcConfigReqParameters params;
         params.m_rnti = lcinfo.rnti;
         params.m_reconfigureFlag = false;
 
-        struct LogicalChannelConfigListElement_s lccle;
+        LogicalChannelConfigListElement_s lccle;
         lccle.m_logicalChannelIdentity = lcinfo.lcId;
         lccle.m_logicalChannelGroup = lcinfo.lcGroup;
         lccle.m_direction = LogicalChannelConfigListElement_s::DIR_BOTH;
-        lccle.m_qosBearerType = lcinfo.isGbr ? LogicalChannelConfigListElement_s::QBT_GBR
-                                             : LogicalChannelConfigListElement_s::QBT_NON_GBR;
         lccle.m_qci = lcinfo.qci;
         lccle.m_eRabMaximulBitrateUl = lcinfo.mbrUl;
         lccle.m_eRabMaximulBitrateDl = lcinfo.mbrDl;
         lccle.m_eRabGuaranteedBitrateUl = lcinfo.gbrUl;
         lccle.m_eRabGuaranteedBitrateDl = lcinfo.gbrDl;
+        lccle.m_qosBearerType =
+            static_cast<LogicalChannelConfigListElement_s::QosBearerType_e>(lcinfo.resourceType);
+
         params.m_logicalChannelConfigList.push_back(lccle);
 
         m_cschedSapProvider->CschedLcConfigReq(params);
@@ -930,7 +932,7 @@
         m_rlcAttached.find(rnti);
     rntiIt->second.erase(lcid);
 
-    struct FfMacCschedSapProvider::CschedLcReleaseReqParameters params;
+    FfMacCschedSapProvider::CschedLcReleaseReqParameters params;
     params.m_rnti = rnti;
     params.m_logicalChannelIdentity.push_back(lcid);
     m_cschedSapProvider->CschedLcReleaseReq(params);
@@ -952,7 +954,7 @@
 LteEnbCmacSapProvider::RachConfig
 LteEnbMac::DoGetRachConfig() const
 {
-    struct LteEnbCmacSapProvider::RachConfig rc;
+    LteEnbCmacSapProvider::RachConfig rc;
     rc.numberOfRaPreambles = m_numberOfRaPreambles;
     rc.preambleTransMax = m_preambleTransMax;
     rc.raResponseWindowSize = m_raResponseWindowSize;
@@ -1296,14 +1298,14 @@
 }
 
 void
-LteEnbMac::DoUlInfoListElementHarqFeeback(UlInfoListElement_s params)
+LteEnbMac::DoUlInfoListElementHarqFeedback(UlInfoListElement_s params)
 {
     NS_LOG_FUNCTION(this);
     m_ulInfoListReceived.push_back(params);
 }
 
 void
-LteEnbMac::DoDlInfoListElementHarqFeeback(DlInfoListElement_s params)
+LteEnbMac::DoDlInfoListElementHarqFeedback(DlInfoListElement_s params)
 {
     NS_LOG_FUNCTION(this);
     // Update HARQ buffer
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-mac.h ns-3.39/src/lte/model/lte-enb-mac.h
--- ns-3.38/src/lte/model/lte-enb-mac.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-mac.h	2023-07-05 14:23:48.009428000 -0700
@@ -24,17 +24,19 @@
 #ifndef LTE_ENB_MAC_H
 #define LTE_ENB_MAC_H
 
-#include "ns3/trace-source-accessor.h"
-#include "ns3/traced-value.h"
-#include <ns3/ff-mac-csched-sap.h>
-#include <ns3/ff-mac-sched-sap.h>
-#include <ns3/lte-ccm-mac-sap.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-enb-cmac-sap.h>
-#include <ns3/lte-enb-phy-sap.h>
-#include <ns3/lte-mac-sap.h>
+#include "ff-mac-csched-sap.h"
+#include "ff-mac-sched-sap.h"
+#include "lte-ccm-mac-sap.h"
+#include "lte-common.h"
+#include "lte-enb-cmac-sap.h"
+#include "lte-enb-phy-sap.h"
+#include "lte-mac-sap.h"
+
+#include <ns3/nstime.h>
 #include <ns3/packet-burst.h>
 #include <ns3/packet.h>
+#include <ns3/trace-source-accessor.h>
+#include <ns3/traced-value.h>
 
 #include <map>
 #include <vector>
@@ -365,12 +367,12 @@
      * \brief UL Info List ELements HARQ Feedback function
      * \param params UlInfoListElement_s
      */
-    void DoUlInfoListElementHarqFeeback(UlInfoListElement_s params);
+    void DoUlInfoListElementHarqFeedback(UlInfoListElement_s params);
     /**
      * \brief DL Info List ELements HARQ Feedback function
      * \param params DlInfoListElement_s
      */
-    void DoDlInfoListElementHarqFeeback(DlInfoListElement_s params);
+    void DoDlInfoListElementHarqFeedback(DlInfoListElement_s params);
 
     /// RNTI, LC ID, SAP of the RLC instance
     std::map<uint16_t, std::map<uint8_t, LteMacSapUser*>> m_rlcAttached;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-net-device.cc ns-3.39/src/lte/model/lte-enb-net-device.cc
--- ns-3.38/src/lte/model/lte-enb-net-device.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-net-device.cc	2023-07-05 14:23:48.009428000 -0700
@@ -21,25 +21,25 @@
  * 2015 - Carrier Aggregation
  */
 
+#include "lte-enb-net-device.h"
+
+#include "component-carrier-enb.h"
+#include "lte-anr.h"
+#include "lte-enb-component-carrier-manager.h"
+#include "lte-enb-mac.h"
+#include "lte-enb-phy.h"
+#include "lte-enb-rrc.h"
+#include "lte-ffr-algorithm.h"
+#include "lte-handover-algorithm.h"
+#include "lte-net-device.h"
+
 #include <ns3/abort.h>
 #include <ns3/callback.h>
 #include <ns3/enum.h>
-#include <ns3/ff-mac-scheduler.h>
 #include <ns3/ipv4-l3-protocol.h>
 #include <ns3/ipv6-l3-protocol.h>
 #include <ns3/llc-snap-header.h>
 #include <ns3/log.h>
-#include <ns3/lte-amc.h>
-#include <ns3/lte-anr.h>
-#include <ns3/lte-enb-component-carrier-manager.h>
-#include <ns3/lte-enb-mac.h>
-#include <ns3/lte-enb-net-device.h>
-#include <ns3/lte-enb-phy.h>
-#include <ns3/lte-enb-rrc.h>
-#include <ns3/lte-ffr-algorithm.h>
-#include <ns3/lte-handover-algorithm.h>
-#include <ns3/lte-net-device.h>
-#include <ns3/lte-ue-net-device.h>
 #include <ns3/node.h>
 #include <ns3/object-factory.h>
 #include <ns3/object-map.h>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-net-device.h ns-3.39/src/lte/model/lte-enb-net-device.h
--- ns-3.38/src/lte/model/lte-enb-net-device.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-net-device.h	2023-07-05 14:23:48.009428000 -0700
@@ -23,10 +23,10 @@
 #ifndef LTE_ENB_NET_DEVICE_H
 #define LTE_ENB_NET_DEVICE_H
 
-#include "ns3/component-carrier-enb.h"
+#include "component-carrier.h"
+#include "lte-net-device.h"
+
 #include "ns3/event-id.h"
-#include "ns3/lte-net-device.h"
-#include "ns3/lte-phy.h"
 #include "ns3/mac48-address.h"
 #include "ns3/nstime.h"
 #include "ns3/traced-callback.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-phy.cc ns-3.39/src/lte/model/lte-enb-phy.cc
--- ns-3.38/src/lte/model/lte-enb-phy.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-phy.cc	2023-07-05 14:23:48.009428000 -0700
@@ -20,27 +20,22 @@
 
 #include "lte-enb-phy.h"
 
+#include "lte-common.h"
 #include "lte-control-messages.h"
-#include "lte-enb-mac.h"
-#include "lte-enb-net-device.h"
 #include "lte-net-device.h"
 #include "lte-spectrum-value-helper.h"
-#include "lte-ue-phy.h"
-#include "lte-ue-rrc.h"
+#include "lte-vendor-specific-parameters.h"
 
 #include <ns3/attribute-accessor-helper.h>
 #include <ns3/double.h>
 #include <ns3/log.h>
-#include <ns3/lte-common.h>
-#include <ns3/lte-vendor-specific-parameters.h>
 #include <ns3/object-factory.h>
 #include <ns3/simulator.h>
 
 #include <cfloat>
 #include <cmath>
 
-// WILD HACK for the inizialization of direct eNB-UE ctrl messaging
-#include <ns3/lte-ue-net-device.h>
+// WILD HACK for the initialization of direct eNB-UE ctrl messaging
 #include <ns3/node-list.h>
 #include <ns3/node.h>
 #include <ns3/pointer.h>
@@ -736,7 +731,7 @@
                      it != rarMsg->RarListEnd();
                      ++it)
                 {
-                    if (it->rarPayload.m_grant.m_ulDelay == true)
+                    if (it->rarPayload.m_grant.m_ulDelay)
                     {
                         NS_FATAL_ERROR(" RAR delay is not yet implemented");
                     }
@@ -1161,7 +1156,7 @@
 {
     NS_LOG_FUNCTION(this);
     // forward to scheduler
-    m_enbPhySapUser->UlInfoListElementHarqFeeback(mes);
+    m_enbPhySapUser->UlInfoListElementHarqFeedback(mes);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-phy.h ns-3.39/src/lte/model/lte-enb-phy.h
--- ns-3.38/src/lte/model/lte-enb-phy.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-phy.h	2023-07-05 14:23:48.009428000 -0700
@@ -21,11 +21,11 @@
 #ifndef ENB_LTE_PHY_H
 #define ENB_LTE_PHY_H
 
-#include <ns3/lte-control-messages.h>
-#include <ns3/lte-enb-cphy-sap.h>
-#include <ns3/lte-enb-phy-sap.h>
-#include <ns3/lte-harq-phy.h>
-#include <ns3/lte-phy.h>
+#include "lte-control-messages.h"
+#include "lte-enb-cphy-sap.h"
+#include "lte-enb-phy-sap.h"
+#include "lte-harq-phy.h"
+#include "lte-phy.h"
 
 #include <map>
 #include <set>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-phy-sap.h ns-3.39/src/lte/model/lte-enb-phy-sap.h
--- ns-3.38/src/lte/model/lte-enb-phy-sap.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-phy-sap.h	2023-07-05 14:23:48.009428000 -0700
@@ -20,8 +20,9 @@
 #ifndef LTE_ENB_PHY_SAP_H
 #define LTE_ENB_PHY_SAP_H
 
-#include <ns3/ff-mac-common.h>
-#include <ns3/ff-mac-sched-sap.h>
+#include "ff-mac-common.h"
+#include "ff-mac-sched-sap.h"
+
 #include <ns3/packet.h>
 
 namespace ns3
@@ -109,14 +110,14 @@
      *
      * \param params
      */
-    virtual void UlInfoListElementHarqFeeback(UlInfoListElement_s params) = 0;
+    virtual void UlInfoListElementHarqFeedback(UlInfoListElement_s params) = 0;
 
     /**
      * Notify the HARQ on the DL transmission status
      *
      * \param params
      */
-    virtual void DlInfoListElementHarqFeeback(DlInfoListElement_s params) = 0;
+    virtual void DlInfoListElementHarqFeedback(DlInfoListElement_s params) = 0;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-rrc.cc ns-3.39/src/lte/model/lte-enb-rrc.cc
--- ns-3.38/src/lte/model/lte-enb-rrc.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-rrc.cc	2023-07-05 14:23:48.009428000 -0700
@@ -25,16 +25,18 @@
 
 #include "lte-enb-rrc.h"
 
+#include "component-carrier-enb.h"
+#include "eps-bearer-tag.h"
+#include "lte-pdcp.h"
+#include "lte-radio-bearer-info.h"
+#include "lte-rlc-am.h"
+#include "lte-rlc-tm.h"
+#include "lte-rlc-um.h"
+#include "lte-rlc.h"
+
 #include <ns3/abort.h>
-#include <ns3/eps-bearer-tag.h>
 #include <ns3/fatal-error.h>
 #include <ns3/log.h>
-#include <ns3/lte-pdcp.h>
-#include <ns3/lte-radio-bearer-info.h>
-#include <ns3/lte-rlc-am.h>
-#include <ns3/lte-rlc-tm.h>
-#include <ns3/lte-rlc-um.h>
-#include <ns3/lte-rlc.h>
 #include <ns3/object-factory.h>
 #include <ns3/object-map.h>
 #include <ns3/packet.h>
@@ -204,7 +206,7 @@
         // Iinterface Specification v1.11, 4.3.4 logicalChannelConfigListElement
         lcinfo.lcGroup = 0;
         lcinfo.qci = 0;
-        lcinfo.isGbr = false;
+        lcinfo.resourceType = 0;
         lcinfo.mbrUl = 0;
         lcinfo.mbrDl = 0;
         lcinfo.gbrUl = 0;
@@ -249,7 +251,7 @@
         lcinfo.lcGroup = 0; // all SRBs always mapped to LCG 0
         lcinfo.qci =
             EpsBearer::GBR_CONV_VOICE; // not sure why the FF API requires a CQI even for SRBs...
-        lcinfo.isGbr = true;
+        lcinfo.resourceType = 1;       // GBR resource type
         lcinfo.mbrUl = 1e6;
         lcinfo.mbrDl = 1e6;
         lcinfo.gbrUl = 1e4;
@@ -436,6 +438,7 @@
     Ptr<LteRlc> rlc = rlcObjectFactory.Create()->GetObject<LteRlc>();
     rlc->SetLteMacSapProvider(m_rrc->m_macSapProvider);
     rlc->SetRnti(m_rnti);
+    rlc->SetPacketDelayBudgetMs(bearer.GetPacketDelayBudgetMs());
 
     drbInfo->m_rlc = rlc;
 
@@ -468,7 +471,7 @@
     // lcinfo.lcId = lcid;
     // lcinfo.lcGroup = m_rrc->GetLogicalChannelGroup (bearer);
     // lcinfo.qci = bearer.qci;
-    // lcinfo.isGbr = bearer.IsGbr ();
+    // lcinfo.resourceType = bearer.GetResourceType();
     // lcinfo.mbrUl = bearer.gbrQosInfo.mbrUl;
     // lcinfo.mbrDl = bearer.gbrQosInfo.mbrDl;
     // lcinfo.gbrUl = bearer.gbrQosInfo.gbrUl;
@@ -503,7 +506,7 @@
     drbInfo->m_logicalChannelIdentity = lcid;
     drbInfo->m_logicalChannelConfig.priority = m_rrc->GetLogicalChannelPriority(bearer);
     drbInfo->m_logicalChannelConfig.logicalChannelGroup = m_rrc->GetLogicalChannelGroup(bearer);
-    if (bearer.IsGbr())
+    if (bearer.GetResourceType() > 0) // 1, 2 for GBR and DC-GBR
     {
         drbInfo->m_logicalChannelConfig.prioritizedBitRateKbps = bearer.gbrQosInfo.gbrUl;
     }
@@ -679,7 +682,7 @@
             uint16_t rnti = m_rrc->AddUe(UeManager::HANDOVER_JOINING, componentCarrierId);
             LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue anrcrv =
                 m_rrc->m_cmacSapProvider.at(componentCarrierId)->AllocateNcRaPreamble(rnti);
-            if (anrcrv.valid == false)
+            if (!anrcrv.valid)
             {
                 NS_LOG_INFO(this << " failed to allocate a preamble for non-contention based RA => "
                                     "cannot perform HO");
@@ -958,7 +961,6 @@
     case CONNECTION_SETUP:
         NS_LOG_WARN("not connected, discarding packet");
         return;
-        break;
 
     case CONNECTED_NORMALLY:
     case CONNECTION_RECONFIGURATION:
@@ -1145,7 +1147,7 @@
     case INITIAL_RANDOM_ACCESS: {
         m_connectionRequestTimeout.Cancel();
 
-        if (m_rrc->m_admitRrcConnectionRequest == true)
+        if (m_rrc->m_admitRrcConnectionRequest)
         {
             m_imsi = msg.ueIdentity;
 
@@ -1195,7 +1197,7 @@
     {
     case CONNECTION_SETUP:
         m_connectionSetupTimeout.Cancel();
-        if (m_caSupportConfigured == false && m_rrc->m_numberOfComponentCarriers > 1)
+        if (!m_caSupportConfigured && m_rrc->m_numberOfComponentCarriers > 1)
         {
             m_pendingRrcConnectionReconfiguration = true; // Force Reconfiguration
             m_pendingStartDataRadioBearers = true;
@@ -1610,7 +1612,7 @@
     msg.haveMobilityControlInfo = false;
     msg.haveMeasConfig = true;
     msg.measConfig = m_rrc->m_ueMeasConfig;
-    if (m_caSupportConfigured == false && m_rrc->m_numberOfComponentCarriers > 1)
+    if (!m_caSupportConfigured && m_rrc->m_numberOfComponentCarriers > 1)
     {
         m_caSupportConfigured = true;
         NS_LOG_FUNCTION(this << "CA not configured. Configure now!");
@@ -1733,11 +1735,11 @@
         break;
 
     case CONNECTED_NORMALLY: {
-        if (m_pendingRrcConnectionReconfiguration == true)
+        if (m_pendingRrcConnectionReconfiguration)
         {
             ScheduleRrcConnectionReconfiguration();
         }
-        if (m_pendingStartDataRadioBearers == true && m_caSupportConfigured == true)
+        if (m_pendingStartDataRadioBearers && m_caSupportConfigured)
         {
             StartDataRadioBearers();
         }
@@ -2867,7 +2869,7 @@
     NS_LOG_LOGIC("mmeUeS1apId = " << req.mmeUeS1apId);
 
     // if no SRS index is available, then do not accept the handover
-    if (m_admitHandoverRequest == false || IsMaxSrsReached())
+    if (!m_admitHandoverRequest || IsMaxSrsReached())
     {
         NS_LOG_INFO("rejecting handover request from cellId " << req.sourceCellId);
         EpcX2Sap::HandoverPreparationFailureParams res;
@@ -2887,7 +2889,7 @@
     ueManager->SetImsi(req.mmeUeS1apId);
     LteEnbCmacSapProvider::AllocateNcRaPreambleReturnValue anrcrv =
         m_cmacSapProvider.at(componentCarrierId)->AllocateNcRaPreamble(rnti);
-    if (anrcrv.valid == false)
+    if (!anrcrv.valid)
     {
         NS_LOG_INFO(
             this
@@ -3121,6 +3123,7 @@
     // if no SRS index is available, then do not create a new UE context.
     if (IsMaxSrsReached())
     {
+        NS_LOG_WARN("Not enough SRS configuration indices, UE context not created");
         return 0; // return 0 since new RNTI was not assigned for the received preamble
     }
     return AddUe(UeManager::INITIAL_RANDOM_ACCESS, componentCarrierId);
@@ -3310,15 +3313,12 @@
     {
     case RLC_SM_ALWAYS:
         return LteRlcSm::GetTypeId();
-        break;
 
     case RLC_UM_ALWAYS:
         return LteRlcUm::GetTypeId();
-        break;
 
     case RLC_AM_ALWAYS:
         return LteRlcAm::GetTypeId();
-        break;
 
     case PER_BASED:
         if (bearer.GetPacketErrorLossRate() > 1.0e-5)
@@ -3329,11 +3329,9 @@
         {
             return LteRlcAm::GetTypeId();
         }
-        break;
 
     default:
         return LteRlcSm::GetTypeId();
-        break;
     }
 }
 
@@ -3487,20 +3485,13 @@
     NS_ASSERT(m_srsCurrentPeriodicityId < SRS_ENTRIES);
     NS_LOG_DEBUG(this << " SRS p " << g_srsPeriodicity[m_srsCurrentPeriodicityId] << " set "
                       << m_ueSrsConfigurationIndexSet.size());
-    if (m_ueSrsConfigurationIndexSet.size() >= g_srsPeriodicity[m_srsCurrentPeriodicityId])
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    return m_ueSrsConfigurationIndexSet.size() >= g_srsPeriodicity[m_srsCurrentPeriodicityId];
 }
 
 uint8_t
 LteEnbRrc::GetLogicalChannelGroup(EpsBearer bearer)
 {
-    if (bearer.IsGbr())
+    if (bearer.GetResourceType() > 0) // 1, 2 for GBR and DC-GBR
     {
         return 1;
     }
@@ -3561,10 +3552,8 @@
     case UeManager::CONNECTED_NORMALLY:
     case UeManager::CONNECTION_RECONFIGURATION:
         return true;
-        break;
     default:
         return false;
-        break;
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-enb-rrc.h ns-3.39/src/lte/model/lte-enb-rrc.h
--- ns-3.38/src/lte/model/lte-enb-rrc.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-enb-rrc.h	2023-07-05 14:23:48.009428000 -0700
@@ -27,22 +27,20 @@
 #ifndef LTE_ENB_RRC_H
 #define LTE_ENB_RRC_H
 
-#include <ns3/component-carrier-enb.h>
-#include <ns3/epc-enb-s1-sap.h>
-#include <ns3/epc-x2-sap.h>
+#include "component-carrier.h"
+#include "epc-enb-s1-sap.h"
+#include "epc-x2-sap.h"
+#include "lte-anr-sap.h"
+#include "lte-ccm-rrc-sap.h"
+#include "lte-enb-cmac-sap.h"
+#include "lte-enb-cphy-sap.h"
+#include "lte-ffr-rrc-sap.h"
+#include "lte-handover-management-sap.h"
+#include "lte-mac-sap.h"
+#include "lte-pdcp-sap.h"
+#include "lte-rrc-sap.h"
+
 #include <ns3/event-id.h>
-#include <ns3/ff-mac-csched-sap.h>
-#include <ns3/ff-mac-sched-sap.h>
-#include <ns3/lte-anr-sap.h>
-#include <ns3/lte-ccm-rrc-sap.h>
-#include <ns3/lte-enb-cmac-sap.h>
-#include <ns3/lte-enb-cphy-sap.h>
-#include <ns3/lte-ffr-rrc-sap.h>
-#include <ns3/lte-handover-management-sap.h>
-#include <ns3/lte-mac-sap.h>
-#include <ns3/lte-pdcp-sap.h>
-#include <ns3/lte-rlc.h>
-#include <ns3/lte-rrc-sap.h>
 #include <ns3/nstime.h>
 #include <ns3/object.h>
 #include <ns3/traced-callback.h>
@@ -51,9 +49,6 @@
 #include <set>
 #include <vector>
 
-#define MIN_NO_CC 1
-#define MAX_NO_CC 5 // this is the maximum number of carrier components allowed by 3GPP up to R13
-
 namespace ns3
 {
 
@@ -1637,7 +1632,7 @@
      * The `EpsBearerToRlcMapping` attribute. Specify which type of RLC will be
      * used for each type of EPS bearer.
      */
-    enum LteEpsBearerToRlcMapping_t m_epsBearerToRlcMapping;
+    LteEpsBearerToRlcMapping_t m_epsBearerToRlcMapping;
     /**
      * The `SystemInformationPeriodicity` attribute. The interval for sending
      * system information.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ffr-algorithm.h ns-3.39/src/lte/model/lte-ffr-algorithm.h
--- ns-3.38/src/lte/model/lte-ffr-algorithm.h	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-ffr-algorithm.h	2023-07-05 14:23:48.013428000 -0700
@@ -21,9 +21,10 @@
 #ifndef LTE_FFR_ALGORITHM_H
 #define LTE_FFR_ALGORITHM_H
 
-#include <ns3/epc-x2-sap.h>
-#include <ns3/ff-mac-sched-sap.h>
-#include <ns3/lte-rrc-sap.h>
+#include "epc-x2-sap.h"
+#include "ff-mac-sched-sap.h"
+#include "lte-rrc-sap.h"
+
 #include <ns3/object.h>
 
 #include <map>
@@ -176,7 +177,7 @@
      *
      */
     virtual void DoReportDlCqiInfo(
-        const struct FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params) = 0;
+        const FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params) = 0;
 
     /**
      * \brief DoReportUlCqiInfo
@@ -184,7 +185,7 @@
      *
      */
     virtual void DoReportUlCqiInfo(
-        const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params) = 0;
+        const FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params) = 0;
 
     /**
      * \brief DoReportUlCqiInfo
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lte/model/lte-ffr-distributed-algorithm.cc ns-3.39/src/lte/model/lte-ffr-distributed-algorithm.cc
--- ns-3.38/src/lte/model/lte-ffr-distributed-algorithm.cc	2023-03-16 20:54:23.772869000 -0700
+++ ns-3.39/src/lte/model/lte-ffr-distributed-algorithm.cc	2023-07-05 14:23:48.013428000 -0700
@@ -306,7 +306,7 @@
 
 void
 LteFfrDistributedAlgorithm::DoReportDlCqiInfo(
-    const struct FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedDlCqiInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     NS_LOG_WARN("Method should not be called, because it is empty");
@@ -314,7 +314,7 @@
 
 void
 LteFfrDistributedAlgorithm::DoReportUlCqiInfo(
-    const struct FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params)
+    const FfMacSchedSapProvider::SchedUlCqiInfoReqParameters& params)
 {
     NS_LOG_FUNCTION(this);
     NS_LOG_WARN("Method should not be called, because it is empty");
@@ -465,7 +465,7 @@
                         found = true;
                     }
                 }
-                if (found == false)
+                if (!found)
                 {
                     m_neighborCell.push_back(it->physCellId);
                 }
@@ -587,7 +587,10 @@
 
             for (uint16_t i = 0; i < rbgNum; i++)
             {
-                metricA[i] += cellIt->second * rntpIt->second[i];
+                if (rntpIt->second[i])
+                {
+                    metricA[i] += cellIt->second;
+                }
             }
         }
 
@@ -706,21 +709,19 @@
     }
 
     NS_ASSERT(it1 != m_ueMeasures.end());
-    Ptr<UeMeasure> cellMeasures;
     std::map<uint16_t, Ptr<UeMeasure>>::iterator it2;
     it2 = it1->second.find(cellId);
 
     if (it2 != it1->second.end())
     {
-        cellMeasures = it2->second;
-        cellMeasures->m_cellId = cellId;
-        cellMeasures->m_rsrp = rsrp;
-        cellMeasures->m_rsrq = rsrq;
+        it2->second->m_cellId = cellId;
+        it2->second->m_rsrp = rsrp;
+        it2->second->m_rsrq = rsrq;
     }
     else
     {
         // insert a new cell entry
-        cellMeasures = Create<UeMeasure>();
+        Ptr<UeMeasure> cellMeasures = Create<UeMeasure>();
         cellMeasures->m_cellId = cellId;
         cellMeasures->m_rsrp = rsrp;
         cellMeasures->m_rsrq = rsrq;
